Attribute VB_Name = "Include_dll"
Option Explicit

'Declare WIN95IO.DLL for use
'Declare Sub vbOut Lib "WIN95IO.DLL" (ByVal nPort As Integer, ByVal nData As Integer)
'Declare Sub vbOutw Lib "WIN95IO.DLL" (ByVal nPort As Integer, ByVal nData As Integer)
'Declare Function vbIn Lib "WIN95IO.DLL" (ByVal nPort As Integer) As Integer
'Declare Function vbInw Lib "WIN95IO.DLL" (ByVal nPort As Integer) As Integer

' 27 Mar 2003 -- WinIO Driver Notes
'
'  1)  Copy the files WinIO.dll, WinIO.sys, and WinIO.vxd to the
'      executable directory.  If you are working on a VB project, prior
'      to creating an executable, these files must go into the VB executable
'      directory (not the project directory):
'      C:\Program Files\Microsoft Visual Studio\VB98
'
'  2)  Make sure there is a call to InitializeWinIO in the Form_Load() event
'      and then there is a call to ShutdownWinIO in the Form_Unload() event.
'      Otherwise, the IO driver will hang and you have to restart VB to get it
'      to work.
'
'  3)  Use this version of include_dll.bas instead of the WIN95IO.DLL version
'      which used the Win95io.dll library)
'
'  That's it.  The functions from the Win95IO.DLL library are mapped with the
'    names created below.
'

'-------------------------- WinIO Driver  -------------
Declare Function MapPhysToLin Lib "WinIo.dll" (ByVal PhysAddr As Long, ByVal PhysSize As Long, ByRef PhysMemHandle) As Long
Declare Function UnmapPhysicalMemory Lib "WinIo.dll" (ByVal PhysMemHandle, ByVal LinAddr) As Boolean
Declare Function GetPhysLong Lib "WinIo.dll" (ByVal PhysAddr As Long, ByRef PhysVal As Long) As Boolean
Declare Function SetPhysLong Lib "WinIo.dll" (ByVal PhysAddr As Long, ByVal PhysVal As Long) As Boolean
Declare Function GetPortVal Lib "WinIo.dll" (ByVal PortAddr As Integer, ByRef PortVal As Long, ByVal bSize As Byte) As Boolean
Declare Function SetPortVal Lib "WinIo.dll" (ByVal PortAddr As Integer, ByVal PortVal As Long, ByVal bSize As Byte) As Boolean
Declare Function InitializeWinIo Lib "WinIo.dll" () As Boolean
Declare Function ShutdownWinIo Lib "WinIo.dll" () As Boolean
Declare Function InstallWinIoDriver Lib "WinIo.dll" (ByVal DriverPath As String, ByVal Mode As Integer) As Boolean
Declare Function RemoveWinIoDriver Lib "WinIo.dll" () As Boolean
'-------------------------- WinIO Driver  -------------


' Create wrapper functions for the WinIO library/driver for Windows NT/2000/XP
'   to match the same names as the WIN95IO.DLL calls shown above
Public Function vbIn(ByVal nPort As Integer) As Integer
  Dim Result As Boolean, nPortVal As Long
  
  Result = GetPortVal(nPort, nPortVal, 1)
  vbIn = nPortVal
  ' If Result is False, then there was an error
  If Result = False Then ' If Not Result    is not the same as   If Result = False    !!!!!!!!!
    ShutdownWinIo
    Err.Raise 999, , "Error calling vbIn" + vbCrLf + _
                     "Port is " + Str(nPort)
  End If
End Function

Public Function vbInw(ByVal nPort As Integer) As Integer
  vbInw = vbIn(nPort)
End Function

Public Sub vbOut(ByVal nPort As Integer, ByVal nData As Long)
  Dim Result As Integer
 
  Result = SetPortVal(nPort, nData, 1)
  
  If Result = False Then
    ShutdownWinIo
    Err.Raise 999, , "Error calling vbOut" + vbCrLf + _
                     "Port is " + Str(nPort) + vbCrLf + _
                     "Value is " + Str(nData)
  End If
End Sub

Public Sub vbOutW(ByVal nPort As Integer, ByVal nData As Long)
  vbOut nPort, nData
End Sub

